/*
 * @author Walther Neuper, member of the ISAC-team, 
 * Copyright (c) 2004 by Walther Neuper 
 * created Sep 28, 2004, 3:40:04 PM
 * Institute for Softwaretechnology, Graz University of Technology, Austria.
 * 
 * Use is subject to license terms.
 */
package isac.functest;

import junit.framework.TestCase;

/**
 * The learner solves an example stepwise supported by ISAC
 * (the CalcHead is assumed to be completed already):
 * He requests ISAC to do some steps, to apply certain Tactics
 * (eventually selected from a list of Tactics requested from ISAC),
 * he inputs the next formula.
 * He also redoes parts of the example by setting the ActiveFormula
 * to a Formula somewhere in the calculation and applies another Tactic
 * or inputs another Formula.
 * 
 * @see <isac.functest.TestModel> for input of items to the Model on the
 * 		CalcHead and requesting related help from ISAC.
 * @see <isac.functest.TestSpecify> for specifying theories, 
 * 		problems and methods (via CalcHead) in the math knowledge base.
 * @see <isac.functest.TestAlgebraSysten> for automated solving.
 * 
 * @author Walther Neuper Sep 28, 2004, 3:40:04 PM
 * @version 1.0
 **/
public class TestSolveStepwise extends TestCase {

	public void testXxx() {
		System.out.println("---BEGIN isac.functest.TestSolveStepwise#testXxx");
		System.out.println("TODO");
		assertEquals("TODO","TODO");
		System.out.println("---END isac.functest.TestSolveStepwise#testXxx");
	}
}
