/****************************************************************** 
* Copyright (c) 2003, Mario Hochreiter, Student of 
* Software Engineering at FH-Hagenberg, Austria. 
* Project member of the isac team at the Institute for 
* Software-Technologie, Graz University of Technology, Austria. 
* 
* Use is subject to license terms.
******************************************************************/

package isac.gui.browser;

import isac.gui.WindowApplication;
import isac.gui.util.Hierarchy;

import java.awt.BorderLayout;
import java.awt.event.MouseListener;

import javax.swing.JFrame;
import javax.swing.JPanel;
import javax.swing.JTree;
import javax.swing.tree.TreeModel;
import javax.swing.tree.TreeSelectionModel;

/**
 * @author Mario Hochreiter
 * @version 1.0
 *
 */
public abstract class TabPanel extends JPanel {
  protected JTree viewTree;
  /** Handles double clicks on a tree node */
  protected MouseListener ml;
  
  /** The mother Frame */
  protected WindowApplication root;
  
  public TabPanel(JFrame root, Hierarchy hierarchy) {
    this.root = (WindowApplication)root;
    TreeModel model = new BrowserTreeModel(hierarchy);
//    this.initMouseListener();
    this.initTree(model);
    this.setLayout(new BorderLayout());
    this.add(viewTree, BorderLayout.CENTER);  
  }
  
  private void initTree(TreeModel model) {
    viewTree = new JTree(model);
    viewTree.getSelectionModel().setSelectionMode(
                                      TreeSelectionModel.SINGLE_TREE_SELECTION);
  }
}
