/*
 * Created on Jul 5, 2003
 */
package isac.kestore;

import java.io.IOException;

import org.apache.log4j.PropertyConfigurator;
import org.apache.xmlrpc.WebServer;

/**
 * @author Andreas Griesmayer
 */
public class KEStore {
	/**
	 * starts the XML-RPC server for the KE-Store and assignes it to port 1030.
	 * All services are located in KEStoreServices
	 * 
	 * sets PropertyConfigurator for log4j
	 * 
	 * @param args
	 *            0: path to xmldata 1: path to log4j.properties
	 * 
	 * @see KEStoreServices
	 */
	public static void main(String[] args) {
		String path0, path1;
		if (args.length == 2) {
			path0 = args[0];
			path1 = args[1];
			try {
				// Start the server.
				System.out
						.println("Server: starting XML-RPC server on port 1030");
				WebServer server = new WebServer(1030);
				server.setParanoid(false);
				// Register our handler class.
				server.addHandler("KEStore", new KEStoreServices(path0));

				//  PropertyConfigurator for log4j
				PropertyConfigurator.configure(args[1]);
			} catch (IOException e) {
				System.out.println("Server: could not start server: "
						+ e.getMessage());
			} finally {
				System.out
						.println("Server: registered HelloHandler class to 'hello'");
				System.out.println("Server: now accepting requests...");
			}
		} else System.out.println("Invalid arguments for main: paths to xmldata, log4j.properties");
	}
}