(* interface to knowledge interpreter
   use"../FE-interface/interface.sml";
   use"FE-interface/interface.sml";
  use"interface.sml";

 print_depth 11;locatetac;print_depth 3;
 print_depth 11;e_calcstate';print_depth 3;
   *)


(***. CalcTree .***)

(** add and delete users **)

(*.'Iterator 1' must exist with each CalcTree; 
   the only for updating the calc-tree
   WN.0411: only 'Iterator 1' is stored,
   all others are just calculated on the fly 
   TODO: adapt Iterator, add_user(= add_iterator!),etc. accordingly .*)
fun Iterator (cI:calcID) = (*returned ID unnecessary after WN.0411*)
    adduserOK2xml cI (add_user (cI:calcID));
fun IteratorTEST (cI:calcID) = add_user (cI:calcID);
(*fun DEconstructIterator (cI:calcID) (uI:iterID) = 
    deluserOK2xml (del_user cI uI);*)

fun CalcTree
	[(fmz, sp):fmz] (*for several variants lateron*) =
(* val [(fmz, sp)] = [(["equality (1+-1*2+x=0)", "solveFor x","solutions L"],
       ("Test.thy", 
	["linear","univariate","equation","test"],
	["Test","solve_linear"]))];
   *)
    let val cs = nxt_specify_init_calc (fmz, sp)
	(*FIXME.WN.8.03: error-handling missing*)
	val cI = add_calc cs
    in calctreeOK2xml cI  end;

fun DEconstrCalcTree (cI:calcID) = 
    deconstructcalctreeOK2xml (del_calc cI);


fun getActiveFormula (cI:calcID) = iteratorOK2xml cI (get_pos cI 1);

fun moveActiveFormula (cI:calcID) (p:pos') =
    let val ((pt,_),_) = get_calc cI
    in if existpt' p pt then (upd_ipos cI 1 p; iteratorOK2xml cI p)
       else sysERROR2xml cI "frontend sends a non-existing pos" end;
 
(* val (cI, tac) = (1, Add_Given "equality (x ^^^ 2 + 4 * x + 3 = 0)");
   val (cI, tac) = (1, Specify_Theory "PolyEq.thy");
   val (cI, tac) = (1, Specify_Problem ["normalize","polynomial",
				   "univariate","equation"]);
   val (cI, tac) = (1, Subproblem ("Poly.thy",
			      ["polynomial","univariate","equation"]));
   val (cI, tac) = (1, Model_Problem["linear","univariate","equation","test"]);
   val (cI, tac) = (1, Detail_Set "Test_simplify");
   val (cI, tac) = (1, Apply_Method ["Test", "solve_linear"]);
   *)
fun setNextTactic (cI:calcID) tac =
    let val ((pt, _), _) = get_calc cI
	val ip = get_pos cI 1
    in case locatetac tac (pt, ip) of
(* val ("ok", (tacis, _)) = locatetac tac (pt, ip);
   *)
	   ("ok", (tacis, _, _)) => 
	   (upd_calc cI ((pt, ip), tacis); setnexttactic2xml cI "ok")
	 | ("unsafe-ok", (tacis, _, _)) => 
	   (upd_calc cI ((pt, ip), tacis); setnexttactic2xml cI "unsafe-ok")
	 | ("not-applicable",_) => setnexttactic2xml cI "not-applicable"   
	 | ("end-of-calculation",_) => 
	   setnexttactic2xml cI "end-of-calculation"   
	 | ("failure",_) => sysERROR2xml cI "failure"
    end;

fun fetchProposedTactic (cI:calcID) = 
    (case step (get_pos cI 1) (get_calc cI) of
	   ("ok", (ts as (tac,_,_)::_, _, _)) => 
	   (upd_tacis cI ts; fetchproposedtacticOK2xml cI tac)
	 | ("helpless",_) => fetchproposedtacticERROR2xml cI "helpless"
	 | ("no-fmz-spec",_) => fetchproposedtacticERROR2xml cI "no-fmz-spec"
	 | ("end-of-calculation",_) => 
	   fetchproposedtacticERROR2xml cI "end-of-calculation")
    handle _ => sysERROR2xml cI "";

(*datatype auto = FIXXXME040624: does NOT match util/interfaces/ITOCalc.java 
  Step of int      (*1 do #int steps (may stop in model/specify)
		     IS VERY INEFFICIENT IN MODEL/SPECIY*)
| CompleteModel    (*2 complete modeling
                     if model complete, finish specifying*)
| CompleteCalcHead (*3 complete model/specify in one go*)
| CompleteToSubpbl (*4 stop at the next begin of a subproblem,
                     if none, complete the actual (sub)problem*)
| CompleteSubpbl   (*5 complete the actual (sub)problem (incl.ev.subproblems)*)
| CompleteCalc;    (*6 complete the calculation as a whole*)*)	
fun autoCalculate (cI:calcID) auto = 
(* val (cI, auto) = (1,CompleteCalc);
   val (cI, auto) = (1,CompleteModel);
   val (cI, auto) = (1,CompleteCalcHead);
   val (cI, auto) = (1,Step 1);
   *)
    let val pold = get_pos cI 1
	val x = autocalc [] pold (get_calc cI) auto
    in
	(case x of
(* val (str, c, ptp as (_,p)) = x;
	      *)
	     ("ok", c, ptp as (_,p)) => 
	     (upd_calc cI (ptp, []); upd_ipos cI 1 p; 
	      autocalculateOK2xml cI pold (if null c then pold 
					   else last_elem c) p)
	   | ("end-of-calculation", c, ptp as (_,p)) => 
	     (upd_calc cI (ptp, []); upd_ipos cI 1 p; 
	      autocalculateOK2xml cI pold (if null c then pold 
					   else last_elem c) p)
	   | (str, _, _) => autocalculateERROR2xml cI str)
	handle _ => sysERROR2xml cI ""
    end;


(* val (cI:calcID, ichd as ((p,_),_,_,_,_):icalhd) =
       (1, (([],Pbl), "not used here",
	[Given ["fixedValues [r=Arbfix]"],
	 Find ["maximum A", "valuesFor [a,b]"(*new input*)], 
	 Relate ["relations [A=a*b, (a/2)^^^2 + (b/2)^^^2 = r^^^2]"]], Pbl, 
       ("DiffApp.thy", ["maximum_of","function"], 
		   ["DiffApp","max_by_calculus"])));
 val (cI:calcID, ichd as ((p,_),_,_,_,_):icalhd) =
       (1, (([],Pbl),"solve (x+1=2, x)",
		  [Given ["equality (x+1=2)", "solveFor x"],
		   Find ["solutions L"]],
		  Pbl, 
		  ("Test.thy", ["linear","univariate","equation","test"],
		   ["Test","solve_linear"])));
 val (cI:calcID, ichd as ((p,_),_,_,_,_):icalhd) =
       (1, (([],Pbl),"solveTest (1+-1*2+x=0,x)", [], Pbl, ("", [], [])));
   *)
fun getTactic cI (p:pos') =
    (let val ((pt,_),_) = get_calc cI
	 val (form, tac, asms) = pt_extract (pt, p)
    in case tac of
	   Some ta => gettacticOK2xml cI ta 
	 | None => gettacticERROR2xml cI ("no tactic at position "^pos'2str p)
     end)
    handle _ => sysERROR2xml cI "syserror in getTactic"; 

(*. see ICalcIterator#fetchApplicableTactics
 @see #TACTICS_ALL
 @see #TACTICS_CURRENT_THEORY
 @see #TACTICS_CURRENT_METHOD  ..the only impl.WN.040307.*)
fun fetchApplicableTactics cI (scope:int) (p:pos') =
    let val ((pt, _), _) = get_calc cI
    in (applicabletacticsOK cI (sel_rules pt p))
       handle PTREE str => sysERROR2xml cI str end;

fun getAssumptions cI (p:pos') =
    (let val ((pt,_),_) = get_calc cI
	 val (_, _, asms) = pt_extract (pt, p)
     in getasmsOK2xml cI asms end)
    handle _ => sysERROR2xml cI "syserror in getAssumptions"; 

(*WN0502 @see ME/ctree: type asms: illdesigned, thus no positions returned*)  
fun getAccumulatedAsms cI (p:pos') =
    (let val ((pt, _), _) = get_calc cI
	 val ass = map fst (get_assumptions_ pt p)
     in (*getaccuasmsOK2xml cI (get_assumptions_ pt p)*) 
     getasmsOK2xml cI ass end)
    handle _ => sysERROR2xml cI "syserror in getAccumulatedAsms";


(*since moveActive* does NOT transfer pos java --> sml (only sml --> java)
  refFormula might become involved in far-off errors !!!*)
fun refFormula cI (p:pos') = (*WN0501 rename to 'fun getFormula' ?!*)
(* val (cI, uI) = (1,1);
   *)
    (let val ((pt,_),_) = get_calc cI
	 val (form, tac, asms) = pt_extract (pt, p)
    in refformulaOK2xml cI p form end)
    handle _ => sysERROR2xml cI ""; (*FIXME.WN.29.8.03 refformulaERROR2xml ? *)

(*from, to are designed for use by iterators of calcChangedEvent;
  thus from is the last unchanged position*)
fun getElementsFromTo cI (from:pos') (to:pos') level false =
(* val (cI, from, to, level) = (1, unc, gen, 0);
   val (cI, from, to, level) = (1, unc, gen, 1);
   *)
    (if from = to then sysERROR2xml cI "getElementsFromTo: From = To"
     else
	 (case from of
	      ([],Res) => sysERROR2xml cI "getElementsFromTo does: moveDown \
					  \from=([],Res) .. goes beyond result"
	    | _ => let val ((pt,_),_) = get_calc cI
		       val f = move_dn [] pt from 
		       fun max (a,b) = if a < b then b else a
		       (*must reach margins ...*)
		       val lev = max (level, max (lev_of from, lev_of to)) 
		   in getintervalOK cI (get_interval f to lev pt) end)
	 handle _ => sysERROR2xml cI "error in getElementsFromTo")
    
  | getElementsFromTo cI from to level true =
    sysERROR2xml cI "getElementsFromTo impl.for tactics only,\
		    \i.e. last arg only true, _NOT_ false";
    

(* val (cI, iI) = (1,1);
   *)
fun interSteps cI (*iI*) ip = 
	let val ((pt,p), tacis) = get_calc cI
	(*val ip = get_pos cI iI*)(*WN050215 quick and dirty*)
	in if fst_onlev ip
	   then interStepsERROR cI "first formula on level has NO \
				   \intermediate steps"
	   else let val ip' = lev_pred' pt ip
		in (case detailstep pt ip of
			("detailrls", pt(*, pos'forms*), lastpos) => 
			(upd_calc cI ((pt, p), tacis);
			 interStepsOK cI (*pos'forms*) ip' ip' lastpos)
		      | ("donesteps", _(*, pos'formshds*), lastpos) => 
			interStepsOK cI (*pos'formshds*) ip' ip' lastpos)
		   handle _ => sysERROR2xml cI "syserror in detailstep"
		end
	end;
	
fun modifyCalcHead (cI:calcID) (ichd as ((p,_),_,_,_,_):icalhd) =
    let val ((pt,_),_) = get_calc cI
    in case input_icalhd pt ichd of
	   (pt, chd as (false,p_,_,_,_,_)) => 
	   (upd_calc cI ((pt, (p,p_)), []);
	    modifycalcheadOK2xml cI "incomplete" chd)
	 | (pt, chd as (true,p_,_,_,_,_)) => 
	   (upd_calc cI ((pt, (p,p_)), []);
	    modifycalcheadOK2xml cI "complete" chd)
    end;

(*. without update of CalcTree .*)

fun tryMatchProblem cI pblID =
    (let val ((pt,_),_) = get_calc cI
	 val p = get_pos cI 1
	 val chd = trymatch pblID pt p
    in trymatchOK2xml cI chd end)
    handle _ => sysERROR2xml cI "";

fun tryRefineProblem cI pblID =
    (let val ((pt,_),_) = get_calc cI
	 val p = get_pos cI 1
	 val chd = tryrefine pblID pt p
    in tryrefineOK2xml cI chd end)
    handle _ => sysERROR2xml cI "";

(* val (cI, ifo) = (1, "-2 * 1 + (1 + x) = 0");
   val (cI, ifo) = (1, "x = 2");
   val (cI, ifo) = (1, "[x = 3 + -2*1]");
   val (cI, ifo) = (1, "-1 + x = 0");
   val (cI, ifo) = (1, "x - 4711 = 0");
   val (cI, ifo) = (1, "2+ -1 + x = 2");
   *)
fun appendFormula cI ifo =
    let val cs = get_calc cI
	val pos as (_,p_) = get_pos cI 1
    in if p_ mem [Pbl, Met] 
       then appendformulaERROR2xml cI "appendFormula not on calc-head"
       else case step pos cs of
(* val (str, cs') = step pos cs;
   *)
		("ok", cs') => 
		(case inform cs' (str2term ifo) of
(* val (str, (_, c, ptp as (_,p))) = inform cs' (str2term ifo);
   *)
		     ("ok", (_(*use in DG !!!*), c, ptp as (_,p))) => 
		     (upd_calc cI (ptp, []); upd_ipos cI 1 p;
		      appendformulaOK2xml cI pos (if null c then pos 
						  else last_elem c) p)
		   | ("same-formula", (_(*use in DG !!!*), c, ptp as (_,p))) =>
		     (upd_calc cI (ptp, []); upd_ipos cI 1 p;
		      appendformulaOK2xml cI pos (if null c then pos 
						  else last_elem c) p)
		   | (msg, _) => appendformulaERROR2xml cI msg)
	      | (msg, cs') => appendformulaERROR2xml cI msg
    end;

(* val (cI, ifo) = (1, "-1 + x = 0");
   val (cI, ifo) = (1, "x - 1 = 0");
   val (cI, ifo) = (1, "-1 + x = 0");
   val (cI, ifo) = (2, "-1 + x = 0");
   *)
fun replaceFormula cI ifo =
    let val ((pt, _), _) = get_calc cI
	val p as (_,p_) = get_pos cI 1
    in if p_ mem [Pbl, Met]
       then replaceformulaERROR2xml cI "replaceFormula not on calc-head"
       else case inform (([], [], (pt, p)): calcstate') (str2term ifo) of
		("ok", (_(*use in DG !!!*), c, ptp' as (pt',p'))) => 
(* val (str, (_,c, ptp as (pt',p)))= inform ([], [], (pt, pos)) (str2term ifo);
   *)
		let val unc = move_up [] pt p
		    val _ = upd_calc cI (ptp', [])
		    val _ = upd_ipos cI 1 p'
		in replaceformulaOK2xml cI unc  
					(if null c then unc 
					 else last_elem c) p end
	      | ("same-formula", _) => 
		(*TODO.WN0501 MESSAGE !*)
		replaceformulaERROR2xml cI "formula not changed"
	      | (msg, _) => replaceformulaERROR2xml cI msg
    end;



(***. CalcIterator 
    moveActive*: set the pos' of the active formula stored with the calctree
                 could take pos' as argument for consistency checks
    move*:       compute the new iterator from the old one on the fly
    
.***)

fun moveActiveRoot cI =
    (let val _ = upd_ipos cI 1 ([],Pbl)
    in iteratorOK2xml cI ([],Pbl) end)
    handle e => sysERROR2xml cI "";
fun moveRoot cI =
    (iteratorOK2xml cI ([],Pbl))
    handle e => sysERROR2xml cI "";
fun moveActiveRootTEST cI =
    (let val _ = upd_ipos cI 1 ([],Pbl)
    in (*iteratorOK2xml cI ([],Pbl)*)() end)
    handle e => sysERROR2xml cI "";

(* val (cI, uI) = (1,1);
   val (cI, uI) = (1,2);
   *)
fun moveActiveDown cI =
    ((let val ((pt,_),_) = get_calc cI
(* val (P, (Nd (_, ns)), (p::(ps as (_::_)), p_)) =([]:pos, pt, get_pos cI uI);
   val (P, (Nd (c, ns)), ([p], p_))               =([]:pos, pt, get_pos cI uI);

   print_depth 7;pt
   *)
	  val ip' = move_dn [] pt (get_pos cI 1)
	  val _ = upd_ipos cI 1 ip'
      in iteratorOK2xml cI ip' end)
     handle (PTREE e) => iteratorERROR2xml cI)
    handle _ => sysERROR2xml cI "";
fun moveDown cI (p:pos') =
    ((let val ((pt,_),_) = get_calc cI
(* val (P, (Nd (_, ns)), (p::(ps as (_::_)), p_)) =([]:pos, pt, get_pos cI uI);
   val (P, (Nd (c, ns)), ([p], p_))               =([]:pos, pt, get_pos cI uI);

   print_depth 7;pt
   *)
	  val ip' = move_dn [] pt p
      in iteratorOK2xml cI ip' end)
     handle (PTREE e) => iteratorERROR2xml cI)
    handle _ => sysERROR2xml cI "";
fun moveActiveDownTEST cI =
    let val ((pt,_),_) = get_calc cI
	val ip = get_pos cI 1
	  val ip' = (move_dn [] pt ip)
	      handle _ => ip
	  val _ = upd_ipos cI 1 ip'
      in (*iteratorOK2xml cI uI*)() end;

fun moveActiveLevelDown cI =
    ((let val ((pt,_),_) = get_calc cI
	  val ip' = movelevel_dn [] pt (get_pos cI 1)
	  val _ = upd_ipos cI 1 ip'
      in iteratorOK2xml cI ip' end)
     handle (PTREE e) => iteratorERROR2xml cI)
    handle _ => sysERROR2xml cI "";
fun moveLevelDown cI (p:pos') =
    ((let val ((pt,_),_) = get_calc cI
	  val ip' = movelevel_dn [] pt p
      in iteratorOK2xml cI ip' end)
     handle (PTREE e) => iteratorERROR2xml cI)
    handle _ => sysERROR2xml cI "";

fun moveActiveUp cI =
    ((let val ((pt,_),_) = get_calc cI
	  val ip' = move_up [] pt (get_pos cI 1)
	  val _ = upd_ipos cI 1 ip'
      in iteratorOK2xml cI ip' end)
     handle PTREE e => iteratorERROR2xml cI)
    handle _ => sysERROR2xml cI "";
fun moveUp cI (p:pos') =
    ((let val ((pt,_),_) = get_calc cI
	  val ip' = move_up [] pt p
      in iteratorOK2xml cI ip' end)
     handle PTREE e => iteratorERROR2xml cI)
    handle _ => sysERROR2xml cI "";

fun moveActiveLevelUp cI =
    ((let val ((pt,_),_) = get_calc cI
	  val ip' = movelevel_up [] pt (get_pos cI 1)
	  val _ = upd_ipos cI 1 ip'
      in iteratorOK2xml cI ip' end)
     handle PTREE e => iteratorERROR2xml cI)
    handle _ => sysERROR2xml cI "";
fun moveLevelUp cI (p:pos') =
    ((let val ((pt,_),_) = get_calc cI
	  val ip' = movelevel_up [] pt p
      in iteratorOK2xml cI ip' end)
     handle PTREE e => iteratorERROR2xml cI)
    handle _ => sysERROR2xml cI "";
    
fun moveActiveCalcHead cI =
    ((let val ((pt,_),_) = get_calc cI
	  val ip' = movecalchd_up pt (get_pos cI 1)
	  val _ = upd_ipos cI 1 ip'
      in iteratorOK2xml cI ip' end)
     handle PTREE e => iteratorERROR2xml cI)
    handle _ => sysERROR2xml cI "";
fun moveCalcHead cI (p:pos') =
    ((let val ((pt,_),_) = get_calc cI
	  val ip' = movecalchd_up pt p
      in iteratorOK2xml cI ip' end)
     handle PTREE e => iteratorERROR2xml cI)
    handle _ => sysERROR2xml cI "";
    

(***. for mathematics authoring on sml-toplevel; no XML .***)

type NEW = int list;
(* val sp = (dI',pI',mI');
   *)

(*15.8.03 for me with loc_specify/solve, nxt_specify/solve
 delete as soon as TESTg_form -> _mout_ dropped*)
fun TESTg_form ptp =
(* val ptp = (pt,p);
   *) 
    let val (form,_,_) = pt_extract ptp
    in case form of
	   Form t => Form' (FormKF (~1,EdUndef,0,Nundef,term2str t))
	 | ModSpec (_,p_, head, gfr, pre, _) => 
	   Form' (PpcKF (0,EdUndef,0,Nundef,
			 (case p_ of Pbl => Problem[] | Met => Method[],
			  itms2itemppc (assoc_thy"Isac.thy") gfr pre)))
    end;

fun CalcTreeTEST [(fmz, sp):fmz] = 
(* val [(fmz, sp):fmz] = [(fmz, (dI',pI',mI'))];
   *)
    let val _ = states:= [];
	val cs as ((pt,p), (tac,_,_)::_) = nxt_specify_init_calc (fmz, sp);
	val f = TESTg_form (pt,p);
	val _ = (add_calc cs;  IteratorTEST 1; moveActiveRootTEST 1);
    in (p, []:NEW, f, (tac2IDstr tac, tac), Sundef, pt) end; 
       
(*for tests > 15.8.03 after separation setnexttactic / nextTac:
  external view: me should be used by math-authors as done so far
  internal view: loc_specify/solve, nxt_specify/solve used
                 i.e. same as in setnexttactic / nextTac*)
(*ENDE TESTPHASE 08/10.03:
  NEW loeschen, eigene Version von locatetac, step
  meNEW, CalcTreeTEST: tac'_ -replace-> tac, remove [](cid) *)


fun meNEW ((_,tac):tac'_) (p:pos') (_:NEW(*remove*)) (pt:ptree) =
(* val (_,tac) = nxt;
   *) let val (pt, p) = 
(* val (eee, (tacis, (pt',p'))) = locatetac tac (pt,p);
   (writeln o (itms2str thy)) (get_obj g_pbl pt' (fst p'));
   writeln( istate2str (get_istate pt' ([3],Res)));
   term2str (fst (get_obj g_result pt' [3]));
   val (pt,p) = (pt',p');
   *)
	    case locatetac tac (pt,p) of
		("ok", (_, _, ptp))  => ptp
	      | ("unsafe-ok", (_, _, ptp)) => ptp
	      | ("not-applicable",_) => (pt, p)
	      | ("end-of-calculation", (_, _, ptp)) => ptp
	      | ("failure",_) => raise error "sys-error";
	val (_, ts) = 
(* (writeln o (itms2str thy)) (get_obj g_pbl pt (fst p));
   val (eee, (ts, (pt'',_))) = step p ((pt, e_pos'),[]);
   (writeln o (itms2str thy)) (get_obj g_pbl pt'' (fst p));
   *)
	    (case step p ((pt, e_pos'),[]) of
		 ("ok", (ts as (tac,_,_)::_, _, _)) => ("",ts)
	       | ("helpless",_) => ("helpless: cannot propose tac", [])
	       | ("no-fmz-spec",_) => raise error "no-fmz-spec"
	       | ("end-of-calculation", (ts, _, _)) => ("",ts))
	    handle _ => raise error "sys-error";
	val tac = case ts of ((tac,_,_)::_) => tac 
			   | _ => if p = ([],Res) then End_Proof'
				  else Empty_Tac;
    in (p:pos',[]:NEW, TESTg_form (pt, p), 
	(tac2IDstr tac, tac):tac'_, Sundef, pt) end;

(********************************************************************)
(****************) val me = meNEW; (*********************************)
(********************************************************************)

