(* remark on 'polynomials'
   WN.19.9.02
   there are 5 kinds of expanded normalforms:
[1] 'complete polynomial' (Komplettes Polynom), univariate
   a_0 + a_1.x^1 +...+ a_n.x^n   not (a_n = 0)
	        not (a_n = 0), some a_i may be zero (DON'T disappear),
                variables in monomials lexicographically ordered and complete,
                x written as 1*x^1, ...
[2] 'polynomial' (Polynom), univariate and multivariate
   a_0 + a_1.x +...+ a_n.x^n   not (a_n = 0)
   a_0 + a_1.x_1.x_2^n_12...x_m^n_1m +...+  a_n.x_1^n.x_2^n_n2...x_m^n_nm
	        not (a_n = 0), some a_i may be zero (ie. monomials disappear),
                exponents and coefficients equal 1 are not shown,
                and variables in monomials are lexicographically ordered  
   examples: [1]: "1 + (-10) * x ^^^ 1 + 25 * x ^^^ 2"
	     [1]: "11 + 0 * x ^^^ 1 + 1 * x ^^^ 2"
	     [2]: "x + (-50) * x ^^^ 3"
	     [2]: "(-1) * x * y ^^^ 2 + 7 * x ^^^ 3"

[3] 'expanded_term' (Ausmultiplizierter Term):
   pull out unary minus to binary minus, 
   as frequently exercised in schools; other conditions for [2] hold however
   examples: "a ^^^ 2 - 2 * a * b + b ^^^ 2"
	     "4 * x ^^^ 2 - 9 * y ^^^ 2"
[4] 'polynomial_in' (Polynom in): 
   polynomial in 1 variable with arbitrary coefficients
   examples: "2 * x + (-50) * x ^^^ 3"                     (poly in x)
	     "(u + v) + (2 * u ^^^ 2) * a + (-u) * a ^^^ 2 (poly in a)
[5] 'expanded_in' (Ausmultiplizierter Termin in): 
   analoguous to [3] with binary minus like [3]
   examples: "2 * x - 50 * x ^^^ 3"                     (expanded in x)
	     "(u + v) + (2 * u ^^^ 2) * a - u * a ^^^ 2 (expanded in a)

*)


val t = (#prop o rep_thm) real_diff_0; (*"0 - ?x = - ?x"*)
atomty thy t;
(*** -------------
*** Const ( Trueprop, bool => prop)
*** . Const ( op =, [real, real] => bool)
*** . . Const ( op -, [real, real] => real)
*** . . . Const ( 0, real)
*** . . . Var ((x, 0), real)
*** . . Const ( uminus, real => real)
*** . . . Var ((x, 0), real)              *)

val t = (term_of o the o (parse thy)) "-1";
atomty thy t;
(*** -------------
*** Free ( -1, real)                      *)
val t = (term_of o the o (parse thy)) "- 1";
atomty thy t;
(*** -------------
*** Const ( uminus, real => real)
*** . Free ( 1, real)                     *)

val t = (term_of o the o (parse thy)) "-x"; (*1-x  syntyx error !!!*)
atomty thy t;
(**** -------------
*** Free ( -x, real)*)
val t = (term_of o the o (parse thy)) "- x";
atomty thy t;
(**** -------------
*** Free ( -x, real) !!!!!!!!!!!!!!!!!!!!!!!! is the same !!!*)
val t = (term_of o the o (parse thy)) "-(x)";
atomty thy t;
(**** -------------
*** Free ( -x, real)*)





