(* tools which depend on Script.thy and thus are not in term_G.sml
   use"Scripts/scrtools.sml";
   *)

fun is_reall_dsc 
  (Const(_,Type("fun",[Type("List.list",
			    [Type ("real",[])]),_]))) = true
  | is_reall_dsc 
  (Const(_,Type("fun",[Type("List.list",
			    [Type ("real",[])]),_])) $ t) = true
  | is_reall_dsc _ = false;
fun is_booll_dsc 
  (Const(_,Type("fun",[Type("List.list",
			    [Type ("bool",[])]),_]))) = true
  | is_booll_dsc 
  (Const(_,Type("fun",[Type("List.list",
			    [Type ("bool",[])]),_])) $ t) = true
  | is_booll_dsc _ = false;
(*
> val t = (term_of o the o (parse thy)) "relations";
> atomtyp (type_of t);
*** Type (fun,[
***   Type (List.list,[
***     Type (bool,[])
***     ]
***   Type (Tools.una,[])
***   ]
> is_booll_dsc t;
val it = true : bool
> is_reall_dsc t;
val it = false : bool
*)

fun is_list_dsc (Const(_,Type("fun",[Type("List.list",_),_]))) = true
  | is_list_dsc (Const(_,Type("fun",[Type("List.list",_),_])) $ t) = true
  (*WN:8.5.03: ???                                           ~~~~ ???*)
  | is_list_dsc _ = false;
(*
> val t = str2term "someList";
> is_list_dsc t; 
val it = true : bool

> val t = (term_of o the o (parse thy))
          "additional_relations [a=b,c=(d::real)]";
> is_list_dsc t;
val it = true : bool
> is_list_dsc (head_of t);
val it = true : bool

> val t = (term_of o the o (parse thy))"max_relation (A=#2*a*b-a^^^#2)";
> is_list_dsc t;
val it = false : bool
> is_list_dsc (head_of t);
val it = false : bool     
> val t = (term_of o the o (parse thy)) "testdscforlist";
> is_list_dsc (head_of t);
val it = true : bool
*)


fun is_unl (Const(_,Type("fun",[_,Type("Tools.unl",_)]))) = true
  | is_unl _ = false;
(*
> val t = str2term "someList"; is_unl t;
val it = true : bool
> val t = (term_of o the o (parse thy)) "maximum";
> is_unl t;
val it = false : bool
*)

fun is_dsc (Const(_,Type("fun",[_,Type("Tools.nam",_)]))) = true
  | is_dsc (Const(_,Type("fun",[_,Type("Tools.una",_)]))) = true
  | is_dsc (Const(_,Type("fun",[_,Type("Tools.unl",_)]))) = true
  | is_dsc (Const(_,Type("fun",[_,Type("Tools.str",_)]))) = true
  | is_dsc (Const(_,Type("fun",[_,Type("Tools.toreal",_)]))) = true
  | is_dsc (Const(_,Type("fun",[_,Type("Tools.toreall",_)])))= true
  | is_dsc (Const(_,Type("fun",[_,Type("Tools.unknow",_)])))= true
  | is_dsc (Const(_,Type("fun",[_,Type("Tools.cpy",_)])))= true
  | is_dsc _ = false;
(*
> val t = (term_of o the o (parse thy)) "maximum";
> is_dsc t;
val it = true : bool
> val t = (term_of o the o (parse thy)) "testdscforlist";
> is_dsc t;
val it = true : bool

> val t = (head_of o term_of o the o (parse thy)) "maximum A";
> is_dsc t;
val it = true : bool
> val t = (head_of o term_of o the o (parse thy)) 
  "fixed_values [R=(R::real)]";
> is_dsc t;
val it = true : bool
*)


(*make the term 'Subproblem (domID, pblID)' to a formula for frontend;
  needs to be here after def. Subproblem in Script.thy*)
val t as (subpbl_t $ (pair_t $ Free (domID,_) $ pblID)) = 
    (term_of o the o (parse Script.thy)) 
	"Subproblem (Isac,[equation,univar])";
val t as (pbl_t $ _) = 
    (term_of o the o (parse Script.thy)) 
	"Problem (Isac,[equation,univar])";
val Free (_, ID_type) = (term_of o the o (parse Script.thy)) "x::ID";


fun subpbl domID pblID =
    subpbl_t $ (pair_t $ Free (domID,ID_type) $ 
	(((list2isalist ID_type) o (map (mk_free ID_type))) pblID));
(*> subpbl "Isac" ["equation","univar"] = t;
val it = true : bool *)


fun pblterm (domID:domID) (pblID:pblID) =
    pbl_t $ (pair_t $ Free (domID,ID_type) $ 
	(((list2isalist ID_type) o (map (mk_free ID_type))) pblID));


(**.construct scr-env from scr(created automatically) and Rewrite_Set.**)

fun one_scr_arg (Const _ $ arg $ _) = arg
  | one_scr_arg t = raise error ("one_scr_arg: called by "^(term2str t));
fun two_scr_arg (Const _ $ a1 $ a2 $ _) = (a1, a2)
  | two_scr_arg t = raise error ("one_scr_arg: called by "^(term2str t));


(**.generate calc from a script.**)

(*.instantiate a stactic or scriptexpr, and ev. attach (curried) argument
args:
   E       environment
   v       current value, is attached to curried stactics
   stac     stactic to be instantiated
precond:
   not (a = None) /\ (v = e_term) /\ (stac curried, i.e. without last arg.)
   this ........................ is the initialization for assy with l=[],
   but the 1st stac is
   (a) curried:     then (a = Some _), or 
   (b) not curried: then the values of the initialization are not used
.*)
datatype stacexpr = STac of term | Expr of term
fun rep_stacexpr (STac t ) = t
  | rep_stacexpr (Expr t) = 
    raise error ("rep_stacexpr called with t= "^(term2str t));

type env = (term * term) list;

(*update environment; t <> empty if coming from listexpr*)
fun upd_env (env:env) (v,t) =
  let val env' = if t = e_term then env else overwrite (env,(v,t));
    (*val _= writeln("### upd_env: = "^(subst2str env'));*)
  in env' end;

(*FIXME curried args: subst_stacexpr NEEDS SPOURIOUSLY: E a v *)
fun subst_stacexpr E a v (t as (Const ("Script.Rewrite",_) $ _ $ _ $ _ ))=
    STac (subst_atomic (case a of Some a => upd_env E (a,v) | None => E) t)

  | subst_stacexpr E a v (t as (Const ("Script.Rewrite",_) $ _ $ _ ))=
    STac (case a of Some a' => (subst_atomic E (t $ a'))
	     | None => ((subst_atomic E t) $ v))

  | subst_stacexpr E a v 
	      (t as (Const ("Script.Rewrite'_Inst",_) $ _ $ _ $ _ $ _ )) =
    STac (subst_atomic (case a of Some a => upd_env E (a,v) | None => E) t)

  | subst_stacexpr E a v (t as (Const ("Script.Rewrite'_Inst",_) $ _ $ _ $ _))=
    STac (case a of Some a' => subst_atomic E (t $ a')
	     | None => ((subst_atomic E t) $ v))

  | subst_stacexpr E a v (t as (Const ("Script.Rewrite'_Set",_) $ _ $ _ $ _ )) =
    STac (subst_atomic (case a of Some a => upd_env E (a,v) | None => E) t)

  | subst_stacexpr E a v (t as (Const ("Script.Rewrite'_Set",_) $ _ $ _ )) =
    STac (case a of Some a' => subst_atomic E (t $ a')
	     | None => ((subst_atomic E t) $ v))

  | subst_stacexpr E a v 
	      (t as (Const ("Script.Rewrite'_Set'_Inst",_) $ _ $ _ $ _ $ _ )) =
    STac (subst_atomic (case a of Some a => upd_env E (a,v) | None => E) t)

  | subst_stacexpr E a v 
	      (t as (Const ("Script.Rewrite'_Set'_Inst",_) $ _ $ _ $ _ )) =
    STac (case a of Some a' => subst_atomic E (t $ a')
	     | None => ((subst_atomic E t) $ v))

  | subst_stacexpr E a v (t as (Const ("Script.Calculate",_) $ _ $ _ )) =
    STac (subst_atomic (case a of Some a => upd_env E (a,v) | None => E) t)

  | subst_stacexpr E a v (t as (Const ("Script.Calculate",_) $ _ )) =
    STac (case a of Some a' => subst_atomic E (t $ a')
	     | None => ((subst_atomic E t) $ v))

  | subst_stacexpr E a v 
	      (t as (Const("Script.Check'_elementwise",_) $ _ $ _ )) = 
    STac (subst_atomic (case a of Some a => upd_env E (a,v) | None => E) t)
(* val t = (term_of o the o (parseold Isac.thy))
		 "Check_elementwise L_ {v_. Assumptions}";
   val stacstac = subst_atomic E t;
   atomt stacstac;
   *)

  | subst_stacexpr E a v (t as (Const("Script.Check'_elementwise",_) $ _ )) = 
    STac (case a of Some a' => subst_atomic E (t $ a')
		 | None => ((subst_atomic E t) $ v))

  | subst_stacexpr E a v (t as (Const("Script.Or'_to'_List",_) $ _ )) = STac t

  | subst_stacexpr E a v (t as (Const("Script.Or'_to'_List",_))) = (*t $ v*)
    STac (case a of Some a' => subst_atomic E (t $ a')
		 | None => ((subst_atomic E t) $ v))

  | subst_stacexpr E a v (t as (Const ("Script.SubProblem",_) $ _ $ _)) =
    STac (subst_atomic (case a of Some a => upd_env E (a,v) | None => E) t)

  | subst_stacexpr E a v t = 
    Expr (subst_atomic (case a of Some a => upd_env E (a,v) | None => E) t);
(*> val t = str2term "SubProblem(Test_, [linear, univariate, equation, test], [Test, solve_linear]) [bool_ e_, real_ v_]";
> subst_stacexpr [] None e_term t;*)


(*start_at: go to the end of executed stactics; this is
  - the last element LE in ets, except this is in a let:
  - the 1st unfinished subexpr. in a let containing LE -
    within this subexpr. the last elem. wrt. iterations
  and return the location, local env, and 
  ets (containing ev. parallel stacs/subexpr. in let)

  language restriction: _sequential_ let's ONLY !
  miniversion below expects l= l of (last_elem ets)

args:
  l  : loc_ which generated given formula: for || let
  ets: from PblObj
  sc : script not yet(?) used
returns:
  enr: env, res etc. to be passed over until completion and append to ets
       27.4.01: adapt to diss:script-interpreter !!!
  ets: in future versions eventually modified (|| let) TODO

fun start_at ([]:loc_) ([]:ets) (sc:term) =
  (([]:env, []:env, empty, empty, Sundef), []:ets)
  (*neither l nor ets should be =[] ...*)
  | start_at l ets sc =
    let val (_,(_, ens, env, iar, ret, saf)) = last_elem (drop_last ets)
    (*TODO 5.9.00: check several 'User' instead ^^^^^^^^^*) 
    in ((ens, env, iar, ret, saf), ets) end;-----------------------3.5.02*)




fun stacpbls (h $ body) =
  let
    fun scan ts (Const ("Let",_) $ e $ (Abs (v,T,b))) =
      (scan ts e) @ (scan ts b)
      | scan ts (Const ("If",_) $ c $ e1 $ e2) = (scan ts e1) @ (scan ts e2)
      | scan ts (Const ("Script.While",_) $ c $ e $ _) = scan ts e
      | scan ts (Const ("Script.While",_) $ c $ e) = scan ts e
      | scan ts (Const ("Script.Repeat",_) $ e $ _) = scan ts e
      | scan ts (Const ("Script.Repeat",_) $ e) = scan ts e
      | scan ts (Const ("Script.Try",_) $ e $ _) = scan ts e
      | scan ts (Const ("Script.Try",_) $ e) = scan ts e
      | scan ts (Const ("Script.Or",_) $e1 $ e2 $ _) = 
	(scan ts e1) @ (scan ts e2)
      | scan ts (Const ("Script.Or",_) $e1 $ e2) = 
	(scan ts e1) @ (scan ts e2)
      | scan ts (Const ("Script.Seq",_) $e1 $ e2 $ _) = 
	(scan ts e1) @ (scan ts e2)
      | scan ts (Const ("Script.Seq",_) $e1 $ e2) = 
	(scan ts e1) @ (scan ts e2)
      | scan ts t = case subst_stacexpr [] None e_term t of
			STac _ => [t] | Expr _ => []
  in (distinct o (scan [])) body end;
    (*sc = Solve_root_equation ...
> val ts = stacpbls sc;
> writeln (terms2str thy ts);
["Rewrite square_equation_left True e_",
 "Rewrite_Set SqRoot_simplify False e_",
 "Rewrite_Set rearrange_assoc False e_",
 "Rewrite_Set isolate_root False e_",
 "Rewrite_Set norm_equation False e_",
 "Rewrite_Set_Inst [(bdv, v_)] isolate_bdv False e_"]
*)



fun is_calc (Const ("Script.Calculate",_) $ _) = true
  | is_calc (Const ("Script.Calculate",_) $ _ $ _) = true
  | is_calc _ = false;
fun op_of_calc (Const ("Script.Calculate",_) $ Free (op_,_)) = op_
  | op_of_calc (Const ("Script.Calculate",_) $ Free (op_,_) $ _) = op_
  | op_of_calc t = raise error ("op_of_calc called with"^term2str t);

(*######################################################################

 val Script sc = (#scr o rep_rls) Test_simplify;
 val stacs = stacpbls sc;

 val calcs = filter is_calc stacs;
 val ids = map op_of_calc calcs;
 map (curry assoc1 (!calclist')) ids;

 (((map (curry assoc1 (!calclist'))) o (map op_of_calc) o 
  (filter is_calc) o stacpbls) sc):calc list;

######################################################################*)

(**.for automatic creation of scripts from rls.**)

val ScrStep $ _ $ _ =     (*'z not affected by parse: 'a --> real*)
    ((inst_abs thy) o term_of o the o (parse thy)) 
	"Script Stepwise (t_::'z) =\
        \(Repeat\
	\  ((Try (Repeat (Rewrite real_diff_minus False))) @@  \
	\   (Try (Repeat (Rewrite real_add_commute False))) @@ \
	\   (Try (Repeat (Rewrite real_mult_commute False))))  \
	\  t_)"; 
val ScrStep_inst $ Term $ Bdv $ _=(*'z not affected by parse: 'a --> real*)
    ((inst_abs thy) o term_of o the o (parse thy)) 
	"Script Stepwise_inst (t_::'z) (v_::real) =\
        \(Repeat\
	\  ((Try (Repeat (Rewrite_Inst [(bdv,v_)] real_diff_minus False))) @@ \
	\   (Try (Repeat (Rewrite_Inst [(bdv,v_)] real_add_commute False))) @@\
	\   (Try (Repeat (Rewrite_Inst [(bdv,v_)] real_mult_commute False)))) \
	\  t_)"; 
val Repeat $ _ = 
    ((inst_abs thy) o term_of o the o (parseN thy)) 
	"Repeat (Rewrite real_diff_minus False t_)";
val Try $ _ = 
    ((inst_abs thy) o term_of o the o (parseN thy)) 
	"Try (Rewrite real_diff_minus False t_)";
val Cal $ _ =
    ((inst_abs thy) o term_of o the o (parseN thy)) 
	"Calculate plus";
val Rew $ (Free (_,IDtype)) $ _ $ t_ =
    ((inst_abs thy) o term_of o the o (parseN thy)) 
	"Rewrite real_diff_minus False t_";
val Rew_Inst $ Subs $ _ $ _ =
    ((inst_abs thy) o term_of o the o (parseN thy)) 
	"Rewrite_Inst [(bdv,v_)] real_diff_minus False";
val Rew_Set $ _ $ _ =
    ((inst_abs thy) o term_of o the o (parseN thy)) 
	"Rewrite_Set real_diff_minus False";
val Rew_Set_Inst $ _ $ _ $ _ =
    ((inst_abs thy) o term_of o the o (parseN thy)) 
	"Rewrite_Set_Inst [(bdv,v_)] real_diff_minus False";
val SEq $ _ $ _ $ _ =
    ((inst_abs thy) o term_of o the o (parseN thy)) 
	"  ((Try (Repeat (Rewrite real_diff_minus False))) @@  \
        \   (Try (Repeat (Rewrite real_add_commute False))) @@ \
        \   (Try (Repeat (Rewrite real_mult_commute False)))) t_";

fun rule2stac _ (Thm (thmID, _)) = 
    Try $ (Repeat $ (Rew $ Free (thmID, IDtype) $ HOLogic.false_const))
  | rule2stac calc (Calc (c, _)) = 
    Try $ (Repeat $ (Cal $ Free (assoc_calc (calc ,c), IDtype)))
  | rule2stac _ (Rls_ rls) = 
    Try $ (Rew_Set $ Free (id_rls rls, IDtype) $ HOLogic.false_const);
(*val t = rule2stac [] (Thm ("real_diff_minus", num_str real_diff_minus));
atomt t; term2str t;
val t = rule2stac calclist (Calc ("op +", eval_binop "#add_"));
atomt t; term2str t;
val t = rule2stac [] (Rls_ rearrange_assoc);
atomt t; term2str t;
*)
fun rule2stac_inst _ (Thm (thmID, _)) = 
    Try $ (Repeat $ (Rew_Inst $ Subs $ Free (thmID, IDtype) $ 
			      HOLogic.false_const))
  | rule2stac_inst calc (Calc (c, _)) = 
    Try $ (Repeat $ (Cal $ Free (assoc_calc (calc ,c), IDtype)))
  | rule2stac_inst _ (Rls_ rls) = 
    Try $ (Rew_Set_Inst $ Subs $ Free (id_rls rls, IDtype) $ 
			HOLogic.false_const);
(*val t = rule2stac_inst [] (Thm ("real_diff_minus", num_str real_diff_minus));
atomt t; term2str t;
val t = rule2stac_inst calclist (Calc ("op +", eval_binop "#add_"));
atomt t; term2str t;
val t = rule2stac_inst [] (Rls_ rearrange_assoc);
atomt t; term2str t;
*)

(*for appropriate nesting take stacs in _reverse_ order*)
fun @@@ sts [s] = SEq $ s $ sts
  | @@@ sts (s::ss) = @@@ (SEq $ s $ sts) ss;
fun @@ [stac] = stac
  | @@ [s1, s2] = SEq $ s1 $ s2 (*---------vvv--*)
  | @@ stacs = 
    let val s3::s2::ss = rev stacs
    in @@@ (SEq $ s2 $ s3) ss end;
(*
 val rules = (#rules o rep_rls) isolate_root;
 val rs = map (rule2stac calclist) rules;
 val tt = @@ rs;
 atomt tt; writeln (term2str tt);
 *)

fun contain_bdv [] = false
  | contain_bdv (Thm (_, thm)::rs) = 
    if (null o (filter is_bdv) o ids2str o #prop o rep_thm) thm
    then contain_bdv rs
    else true
  | contain_bdv (_::rs) = contain_bdv rs;

fun rules2scr_Rls calc rules = 
    if contain_bdv rules
    then ScrStep_inst $ Term $ Bdv $ 
	 (Repeat $ (((@@ o (map (rule2stac_inst calc))) rules) $ t_))
    else ScrStep $ Term $
	 (Repeat $ (((@@ o (map (rule2stac      calc))) rules) $ t_));
fun rules2scr_Seq calc rules =
    if contain_bdv rules
    then ScrStep_inst $ Term $ Bdv $ 
	 (((@@ o (map (rule2stac_inst calc))) rules) $ t_)
    else ScrStep $ Term $
	 (((@@ o (map (rule2stac      calc))) rules) $ t_);

fun prep_rls Erls = raise error "prep_rls not impl. for Erls"
  | prep_rls (Rls {id,preconds,rew_ord,erls,srls,calc,rules,...}) = 
    let val sc = (rules2scr_Rls (!calclist') rules)
    in Rls {id=id,preconds=preconds,rew_ord=rew_ord,erls=erls,
	    srls=srls,
	    calc = (*FIXXXME.040207 use also for met*)
	    ((map (curry assoc1 (!calclist'))) o (map op_of_calc) o 
	     (filter is_calc) o stacpbls) sc,
	    rules=rules,
	    scr = Script sc} end
  | prep_rls (Seq {id,preconds,rew_ord,erls,srls,calc,rules,...}) = 
    let val sc = (rules2scr_Seq (!calclist') rules)
    in Seq {id=id,preconds=preconds,rew_ord=rew_ord,erls=erls,
	 srls=srls,
	    calc = ((map (curry assoc1 (!calclist'))) o (map op_of_calc) o 
		    (filter is_calc) o stacpbls) sc,
	 rules=rules,
	 scr = Script sc} end
  | prep_rls (Rrls {id,...}) = 
    raise error ("prep_rls not required for Rrls \""^id^"\"");
(*
 val Script sc = (#scr o rep_rls o prep_rls) isolate_root;
 (writeln o term2str) sc;
 val Script sc = (#scr o rep_rls o prep_rls) isolate_bdv;
 (writeln o term2str) sc;
  *)

